#include <REG932.H>
#include <PortConfig.H>

void v_PortConfig(unsigned char ucPortAddr, unsigned char ucPin, unsigned char Config)
{
   if (Config == BiDir)
   {
      ucPin ^= 0xFF;
      switch(ucPortAddr)
	  {
	  case Port0: P0M1 = P0M1 & ucPin;
	              P0M2 = P0M2 & ucPin; break;
      case Port1: P1M1 = P1M1 & ucPin;
	              P1M2 = P1M2 & ucPin; break;
	  case Port2: P2M1 = P2M1 & ucPin;
	              P2M2 = P2M2 & ucPin; break;
	  case Port3: P3M1 = P3M1 & ucPin;
	              P3M2 = P3M2 & ucPin; break;
      default: break;
	  }
   }
   else if (Config == PushPull)
   {
      switch(ucPortAddr)
	  {
	  case Port0: P0M1 = P0M1 & (ucPin ^ 0xFF);
	              P0M2 = P0M2 | ucPin; break;
	  case Port1: P1M1 = P1M1 & (ucPin ^ 0xFF);
	              P1M2 = P1M2 | ucPin; break;
	  case Port2: P2M1 = P2M1 & (ucPin ^ 0xFF);
	              P2M2 = P2M2 | ucPin; break;
	  case Port3: P3M1 = P3M1 & (ucPin ^ 0xFF);
	              P3M2 = P3M2 | ucPin; break;
      default: break;
	  }
   }
   else if (Config == InpOnly)
   {
      switch(ucPortAddr)
	  {
	  case Port0: P0M1 = P0M1 | ucPin;
	              P0M2 = P0M2 & (ucPin ^ 0xFF); break;
	  case Port1: P1M1 = P1M1 | ucPin;
	              P1M2 = P1M2 & (ucPin ^ 0xFF); break;
	  case Port2: P2M1 = P2M1 | ucPin;
	              P2M2 = P2M2 & (ucPin ^ 0xFF); break;
	  case Port3: P3M1 = P3M1 | ucPin;
	              P3M2 = P3M2 & (ucPin ^ 0xFF); break;
      default: break;
	  }
   }
   else // Open-Drain
   {
      switch(ucPortAddr)
	  {
	  case Port0: P0M1 = P0M1 | ucPin;
	              P0M2 = P0M2 | ucPin; break;
	  case Port1: P1M1 = P1M1 | ucPin;
	              P1M2 = P1M2 | ucPin; break;
	  case Port2: P2M1 = P2M1 | ucPin;
	              P2M2 = P2M2 | ucPin; break;
	  case Port3: P3M1 = P3M1 | ucPin;
	              P3M2 = P3M2 | ucPin; break;
      default: break;
	  }
   }
}